#ifndef ABSTRACTSPWBRIDGE_H
#define ABSTRACTSPWBRIDGE_H

#include <QObject>
#include <socexplorerplugin.h>
#define RMAP_MAX_XFER_SIZE 3000 //slightly less than 16kBytes
#include <spw.h>

class abstractSpwBridge : public QObject
{
    Q_OBJECT
public:
    explicit abstractSpwBridge(socexplorerplugin *parent);
    QWidget *getGUI();

public slots:
    virtual bool connectBridge();
    virtual bool disconnectBridge();
    virtual unsigned int Write(unsigned int *Value,unsigned int count, unsigned int address=0)=0;
    virtual unsigned int Read(unsigned int *Value,unsigned int count, unsigned int address=0)=0;
    virtual int pushRMAPPacket(char* packet,int size)=0;
protected:
    socexplorerplugin* plugin;
    QWidget* p_GUI;
private:

};

#endif // ABSTRACTSPWBRIDGE_H
